//MUDIT UPPAL
//DATA VISUALIZATION: Visualizing comics in 2011-2013a nd comparing it with 
//seattle comic-con which happens in March every year(EMERALD COMIC CON)
//modqhx.com


void drawTitle() {
  fill(0);
  textSize(22);
  textAlign(CENTER, CENTER);
  String title = table.getColumnName(currentColumn);
 // text(title, plotX1, plotY1-15);
}

void drawVolumeLabels() { //// y axiss labels
  fill(60);
  textSize(14);
  textAlign(RIGHT, CENTER);
  textFont(myFont);
  //dataMin = 0 datamax = table.getMax
  for (float i = dataMin; i < dataMax; i += volumeInterval) {
    float y = map(i, dataMin, dataMax, plotY2, plotY1);
    if (i == dataMax) {
      textAlign(RIGHT, TOP);
    }
    else {
      textAlign(RIGHT, CENTER);
    }

    text(floor(i), plotX1-10, y);
    line(plotX1 -2, y, plotX1, y);
  }
}
void drawAxisLabels() {

  fill(222, 0, 55);
  textSize(11);
  text("Checkouts\n of Comic\n books", plotX1 - 25, (plotY2+plotY1+19)/2);
  
  textAlign(CENTER);
  text("Month", (plotX1+plotX2)/2, labelY);
  
}
void drawDataHighlights(int col) {
  
  int rowCount = table.getRowCount();
  for(int row = 0; row < rowCount; row++) {
    if(table.isValid(row, col)) {
      float value = table.getFloat(row, col);
      float x = map(months[row], monthMin, monthMax, plotX1, plotX2);
      float y = map(value, dataMin, dataMax, plotY2, plotY1);
      
      if(dist(mouseX, mouseY, x, y) < 3) {
        strokeWeight(10);
        point(x, y);
       // fill(0);
       stroke(127);
        textAlign(TOP, CENTER);
        text(nf(value,0,2) + "(" + months[row] + ")", x, y- 18);
      }
    }
  }
  
}

void drawCurve(int col) {
  beginShape();

  int rowCount = table.getRowCount();

  for (int row = 0; row < rowCount; row++) {
    if (table.isValid(row, col)) {
      float value = interpolators[row].value;
      float x = map(months[row], monthMin, monthMax, plotX1, plotX2);
      float y = map(value, dataMin, dataMax, plotY2, plotY1);
      curveVertex(x, y);

      if ((row == 0) || (row == rowCount -1)) {
        curveVertex(x, y);
      }
    }
  }
  vertex(plotX2, plotY2);
  vertex(plotX1, plotY2);
  endShape(CLOSE);
}
void drawTabs() {
  rectMode(CORNERS);
  noStroke();
  textSize(12);
  textAlign(LEFT);
    fill(222, 0, 55);


  if (tabLeft == null) {
    tabLeft = new float[columnCount];
    tabRight = new float[columnCount];
  }

  float runningX = plotX1;
  tabTop = plotY1 - textAscent() - 15;
  tabBottom = plotY1;

  for (int col = 0; col < columnCount; col++) {
    //  println(columnCount);
    String title = table.getColumnName(col);
    tabLeft[col] = runningX;
    float titleWidth = textWidth(title);
    tabRight[col] = tabLeft[col] + tabPad + titleWidth + tabPad;

    fill(col == currentColumn ? 255 : 244);
    rect(tabLeft[col], tabTop, tabRight[col], tabBottom);

    fill(col == currentColumn ? 0 : 66);
      fill(222, 0, 55);

    text(title, runningX + tabPad, plotY1 - 10);

    runningX = tabRight[col];
  }
}

void drawMonthsLabels() {
  fill(0);
  textSize(12);
  textAlign(CENTER, TOP);
  int rowCount = table.getRowCount();

  for (int row = 0; row < rowCount; row++) {
    if (months[row] % monthInterval == 0) {
      float x = map(months[row], monthMin, monthMax, plotX1, plotX2);

      text(months[row], x, plotY2 + 10);
      stroke(255, 60);
      line(x, plotY1, x, plotY2);
    }
  }
}

void keyPressed() {
  if(key == '[') {
    currentColumn--;
    if(currentColumn < 0) {
      currentColumn = columnCount -1;
    }
  }
  
  if(key == ']') {
    currentColumn++;
    if(currentColumn == columnCount) {
      currentColumn = 0;
    }
  }
}

void mousePressed() {
  
  if(mouseY > tabTop && mouseY < tabBottom) {
    
    for(int col = 0; col < columnCount; col++) {
      if(mouseX > tabLeft[col] && mouseX < tabRight[col]) {
        setColumn(col);
      }
    }
  }
}
void setColumn(int col) {
  if( col != currentColumn) {
    currentColumn = col;
  }
  
  int rowCount = table.getRowCount();
  for(int row = 0; row < rowCount; row++) {
    interpolators[row].target(table.getFloat(row, col));
  }
}

